/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __TR_EVENT_H__
#define __TR_EVENT_H__

#include <stdint.h>

#include "trbase.h"
TR_CLASS(TR_Event);
#include "event_subject.h"

TR_CLASS(TR_Event) {
	intptr_t          id;
	TR_EventSubject   subject;
	void            * data;
	int               serial;
};
TR_INSTANCE_INIT(TR_Event);
TR_CLASSVARS_DECL(TR_Event) {
	int serial;
};

#define TR_eventSetData(event, data)	(((TR_Event)event)->data = (void *)data)

const char * TR_getEventString(TR_Event);

#endif // __TR_EVENT_H__

// vim: set ts=4 sw=4:

