/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdint.h>

#include "tr/event.h"
#include "tr/event_subject.h"
#include "tr/logger.h"
#include "trbase.h"

static
int
eventCtor(void * _this, va_list * params)
{
	TR_Event this = _this;

	this->id      = va_arg(*params, intptr_t);
	this->subject = va_arg(*params, TR_EventSubject);
	this->data    = NULL;
	this->serial  = TR_CLASSVARS(TR_Event, TR_GET_CLASS(this))->serial++;

	return 0;
}

static void eventDtor(void * _this)
{
	TR_Event this = _this;

	this->subject->emitted =
		this->subject->emitted == 0
		? 0 : this->subject->emitted - 1;

	if (0 == this->subject->emitted && this->subject->fin) {
		TR_delete(this->subject);
	}
}

TR_INIT_IFACE(TR_Class, eventCtor, eventDtor, NULL);
TR_CREATE_CLASS(TR_Event, NULL, NULL, TR_IF(TR_Class)) = { 0 };

// vim: set ts=4 sw=4:
