/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <time.h>

#include "trbase.h"
#include "trdata.h"
#include "trhash.h"

#include "tr/event.h"
#include "tr/event_subject.h"
#include "tr/event_dispatcher.h"

void
TR_eventDispatcherShutdown(TR_EventDispatcher this)
{
	TR_eventDispatcherEnqueueEvent(
			this, 
			TR_eventSubjectEmit(
				(TR_EventSubject)this,
				TR_DISPATCHER_EVENT_SHUTDOWN,
				NULL));
	TR_eventDispatcherStop(this);
}

// vim: set ts=4 sw=4:
