/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "trbase.h"
#include "trhash.h"

#include "tr/event_handler.h"

void
TR__eventHandlerClassCleanup(TR_class_ptr class)
{
	while (class) {
		struct c_TR_EventHandler_vars * vars;
		vars = (struct c_TR_EventHandler_vars *)class->vars;
		if (vars->event_methods) {
			TR_hashCleanup(vars->event_methods);
		}
		class = class->parent;
	}
}

// vim: set ts=4 sw=4:
