/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>

#include "trbase.h"
#include "trdata.h"
#include "trhash.h"

#include "tr/event.h"
#include "tr/event_handler.h"

TR_EventDone
TR_eventHandlerHandleEvent(TR_EventHandler this, TR_Event event)
{
	TR_EventMethod_fptr event_func     = NULL;
	TR_HashValue        handle_func_hv = TR_hashGetByVal(
			TR_CLASSVARS(TR_EventHandler, TR_GET_CLASS(this))->event_methods,
			TR_sdbm((unsigned char *)&event->id, sizeof(event->id)));

	TR_loggerLog(TR_logger, TR_LOGGER_DEBUG,
			"%zd - HANDLE(%zd): %s event on %p with no. %d",
			TR_queueSize(this->dispatcher[0]->events),
			event->subject->emitted,
			TR_getEventString(event),
			event->subject,
			event->serial);

	if (! handle_func_hv) {
		return 0;
	}

	event_func = *(TR_EventMethod_fptr *)handle_func_hv->value;

	return event_func(this, event);
}

// vim: set ts=4 sw=4:
