/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>

#include "trbase.h"

#include "tr/event.h"
#include "tr/event_handler.h"

int
TR_eventHandlerIssueEvent(TR_EventHandler this, TR_Event event)
{
	if (event) {
		int i;

		for (i=0; i<this->ndispatcher; i++) {
			TR_eventDispatcherEnqueueEvent(this->dispatcher[i], event);

			TR_loggerLog(TR_logger, TR_LOGGER_DEBUG,
					"%zd - ISSUE(%zd): %s event on %p with no. %d",
					TR_queueSize(this->dispatcher[i]->events),
					event->subject->emitted,
					TR_getEventString(event),
					event->subject,
					event->serial);
		}

		return TRUE;
	}

	return FALSE;
}

// vim: set ts=4 sw=4:
