/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdio.h>
#include <stdint.h>

#include "tr/event.h"
#include "tr/event_subject.h"
#include "tr/logger.h"
#include "trbase.h"

TR_Event
TR_eventSubjectEmit(TR_EventSubject this, int idx, void * data)
{
	intptr_t id    = TR_eventSubjectGetId(this, idx);
	TR_Event event = NULL;

	if (id && ! this->fin) {
		event = TR_new(TR_Event, id, this);
		TR_eventSetData(event, data);
		this->emitted++;
	}

	return event;
}

// vim: set ts=4 sw=4:
