/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdint.h>

#include "tr/event_subject.h"
#include "tr/logger.h"
#include "trbase.h"

intptr_t
TR__eventSubjectId(TR_class_ptr cls, size_t idx)
{
	intptr_t id  = 0;

	while (cls && idx < TR_CLASSVARS(TR_EventSubject, cls)->nevents) {
		id = TR_CLASSVARS(TR_EventSubject, cls)->events[idx];
		if (id) break;
		cls = cls->parent;
	}

	return (id == -1) ? 0 : id;
}

// vim: set ts=4 sw=4:
