/**
 * \file
 *
 * \author	Georg Hopp
 *
 * \copyright
 * Copyright © 2014 Georg Hopp
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <stdint.h>

#include "tr/event.h"
#include "tr/event_subject.h"
#include "tr/logger.h"
#include "trbase.h"

const char *
TR_getEventString(TR_Event event)
{
	TR_class_ptr   cls = (TR_class_ptr)(event->id >> 8);
	size_t         idx = event->id & 0xFF;
	
	idx -= TR_CLASSVARS(TR_EventSubject, cls->parent)->nevents;

	return TR_CLASSVARS(TR_EventSubject, cls)->eventStrings[idx];
}

// vim: set ts=4 sw=4:
